﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;
using Infragistics.Controls.Grids.Primitives;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = CreateTable(4, 10).DefaultView;
        }

        public DataTable CreateTable(int columns, int rows)
        {
            DataTable d = new DataTable();
            Random r = new Random();

            for (int i = 0; i < columns; i++)
            {
                d.Columns.Add(new DataColumn("Column " + i, typeof(int)));
            }
            for (int i = 0; i < rows; i++)
            {
                DataRow row = d.NewRow();

                for (int j = 0; j < columns; j++)
                {
                    row["Column " + j] = r.Next(1000 * i);
                }

                d.Rows.Add(row);
            }
            return d;
        }

        private void HeaderControl_PreviewMouseMove(object sender, MouseEventArgs e)
        {
            if ((sender as HeaderCellControl).Column.ColumnLayout.Columns.Where(t => (t as Column).IsSelected).Count() != 0
            && !(sender as HeaderCellControl).Column.ColumnLayout.Grid.SelectionSettings.SelectedColumns.Contains((sender as HeaderCellControl).Column)
            && e.LeftButton == MouseButtonState.Pressed
                && !Keyboard.IsKeyDown(Key.LeftCtrl))
            {
                (sender as HeaderCellControl).Column.ColumnLayout.Grid.SelectionSettings.SelectedColumns.Add((sender as HeaderCellControl).Column);
            }            
        }

        private void HeaderControl_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            if (!Keyboard.IsKeyDown(Key.LeftCtrl))
            {
                (sender as HeaderCellControl).Column.ColumnLayout.Grid.SelectionSettings.SelectedColumns.Add((sender as HeaderCellControl).Column);
            }            
        }

    }
}
